
#ifndef _dkutil_user_config
#define _dkutil_user_config



#ifdef USE_DKINGYO_INCLUDE_SETTING_LIKE_BOOST
#	include <dkutil/dkutilCriticalSection.h>
#else
#	if DKUTIL_COMPILE_OPTION_MSVC
#		include "../dkutilCriticalSection.h"
#	else
#		include "dkutilCriticalSection.h"
#	endif
#endif



namespace dkutil{

//**********************************************************
//CũNݒ
//**********************************************************

///ZkcCX^[ SSE2ł̃Cuւ̃pX
#define DKUTIL_MYMT_PATH "mymt"

///zlibւ̃pX
#define DKUTIL_ZLIB_PATH "zlib_dk"
///}`XbhZLIB
#define DKUTIL_ZLIB_PATH_MT "zlib_dkMT"
///libpngւ̃pX
#define DKUTIL_LIBPNG_PATH "libpng_dk"
///}`XbhLIBPNG
#define DKUTIL_LIBPNG_PATH_MT "libpng_dkMT"

///OggVorbisSDKւ̃pX
#define DKUTIL_OGG_STATIC_PATH "ogg_static"

#define DKUTIL_VORBIS_STATIC_PATH "vorbis_static"

#define DKUTIL_VORBISFILE_STATIC_PATH "vorbisfile_static"

#define DKUTIL_VORBISENC_STATIC_PATH "vorbisenc_static"

///yaneSDKւ̃pX
#ifdef _DEBUG
#	define DKUTIL_YANESDK3RD_PATH "yaneSDK_d"
#else//release build
#	define DKUTIL_YANESDK3RD_PATH "yaneSDK"
#endif


//**********************************************************
	//Confign̂̂`ĂB(ftHgł͂̂܂܂OKłB
//**********************************************************

///dkutil::singletonƁAgƎv܂B
struct DKConfigUtility{
protected:
	//ϐ͐\󂠂܂񂪁ÃNXɐ錾ȂłB
public:
	DKConfigUtility(){}
	virtual ~DKConfigUtility(){}

	inline void LockThread(){
		private_::GetCriticalSection().Enter();
	}
	inline void UnlockThread(){
		private_::GetCriticalSection().Leave();
	}
	//inline void LockThreadSyndrome(){}
	//inline void UnlockThreadSyndrome(){}
};

//**********************************************************
//}`Xbh̐ݒ
//**********************************************************


//}`XbhȂ
#ifdef _MT //}`XbhŃrh

#	define DKUTIL_LOCKTHREAD(u) try{ u.LockThread()
#	define DKUTIL_UNLOCKTHREAD(u) }catch(...){u.UnlockThread();throw;}u.UnlockThread()
#	define DKUTIL_MULTITHREAD_SYNDROME_LOCK(u)
#	define DKUTIL_MULTITHREAD_SYNDROME_UNLOCK(u)

#	ifdef USE_DKINGYO_MULTITHREAD_CHECKER //}`Xbh`FbJ[g

//ȂSȃ}`Xbhs߂ɃbNȂĂȁH
//ďꏊɂbNBႦ΁AƂIuWFNg(NX)O[oɂ
//XbhԂłɃANZXłꍇȂǂ͈ȉ̃}Ng悤ɂȂ΂ȂȂB
//Ȃ̂dkutilConfig.hUSE_DKINGYO_MULTITHREAD_CHECKERLɂKvB

#		undef	DKUTIL_MULTITHREAD_SYNDROME_LOCK
#		undef	DKUTIL_MULTITHREAD_SYNDROME_UNLOCK
#		define DKUTIL_MULTITHREAD_SYNDROME_LOCK(u)  DKUTIL_LOCKTHREAD(u)
#		define DKUTIL_MULTITHREAD_SYNDROME_UNLOCK(u) DKUTIL_UNLOCKTHREAD(u)
#	endif

#else // VOXbhȂ

#	define DKUTIL_LOCKTHREAD(u) ((void)0)
#	define DKUTIL_UNLOCKTHREAD(u) ((void)0)
#	define DKUTIL_MULTITHREAD_SYNDROME_LOCK(u) ((void)0)
#	define DKUTIL_MULTITHREAD_SYNDROME_UNLOCK(u) ((void)0)

#endif

}//end of dkutil namespace



//**********************************************************
//CũN𔽉f
//**********************************************************
#ifdef _MSC_VER
#pragma comment(lib, DKUTIL_MYMT_PATH )
#endif



#endif //end of include once